;by g0blinish, compile by sjasmplus
	device zxspectrum128
        ORG #6000
begin
; debug grid
;	ld hl,$5800,de,$5803,bc,765:set 6,(hl):ldir

;convert font
	ld hl,zxf
	ld de,$B800
	call dzx7_standard
	
	ld de,$B000
	ld hl,$B800
cf1:
	push de
	ld b,8
cf2:
	ld a,(hl)
	inc hl
	ld (de),a
	inc d
	djnz cf2
	pop de
	inc e
	jr nz,cf1

;init music
	ld a,$10
	ld bc,$7ffd
	out (c),a

	ld hl,song
	call INIT
;setup int
	di
	ld hl,$BE00
	ld de,$BE01
	ld bc,256
	ld (hl),$BF
	ldir
	
	ld a,$C3
	ld ($BFBF),a
	ld hl,intvec
	ld ($BFC0),hl
	ld a,$BE
	ld i,a
	im 2
	ei

runi:
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;out text
	ld ix,t1
	ld de,#4000
ol1:
	push de
	call pr8x4
	pop de
	ld a,e
	add a,32
	ld e,a
	sbc a,a
	and 8
	add a,d
	ld d,a
	ld a,(ix+0)
	or a
	jp nz,ol1

	ld ix,t2
	ld de,#50E6
	call pr8x4

	ei
	halt
	ld hl,$5800
	ld de,$5801
	ld bc,32
	ld (hl),$40+8*7
	ldir

	ld bc,768-64
	ld (hl),$46
	ldir
	ld bc,31
	ld (hl),5*8
	ldir

	call ramk
;key loop
kl:
;Q-UP
	ld a,$FB
	in a,($FE)
	and 1
	jr z,ubr1
;keyup
	ld a,$EF
	in a,($FE)
	and 2 ;9-up
	jr nz,keyd
ubr1:
	ld a,(cy)
	or a
	jr nz, nodlp
	ld a,12
nodlp:
	call ramk
	dec a
	ld (cy),a
	call ramk
	jp kwa

keyd:
;A-down
	ld a,$FD
	in a,($FE)
	and 1
	jr z,dbr1

	ld a,$EF
	in a,($FE)
	and 4 ;8-up
	jr nz,keye
dbr1:
	ld a,(cy)
	cp 11
	jr nz, noulp
	ld a,-1
noulp:
	call ramk
	inc a
	ld (cy),a
	call ramk
	jp kwa
keye: ;?0 or enter or M
;M
	ld a,$7F
	in a,($FE)
	and 4
	jr z,extract

	ld a,$EF
	in a,($FE)
	rra
	jr nc,extract

	ld a,$BF
	in a,($FE)
	rra
	jr nc,extract
	jp kl
kwa:
	ld b,10
kw ei
	halt
	djnz kw
	jp kl

pict:
 dw pic1,pic2,pic3,pic4,pic5,pic6
 dw pic7,pic8,pic9,pic10,pic11,pic12
extract:
;	jr $
	ld hl,(cy)
	ld h,0
	ld de,pict
	add hl,hl
	add hl,de
	ld e,(hl)
	inc hl
	ld d,(hl)
	ex de,hl
	ld de,$B800
	call dzx7_standard
	
	ld ix,$B800
	ld hl,$5800
	ld de,$4000
sp1:
	ld a,(ix+0)
	inc ix
	ld (hl),a
	inc hl
	ld a,(ix+0)
	add a,32
	ld c,a
	inc ix
	ld b,$B0
	push de
 dup 8
  ld a,(bc)
  ld (de),a
  inc b
  inc d
edup
	pop de
	inc e
	jp nz,sp1
	ld a,d
	add a,8
	ld d,a
	cp $58
	jp nz,sp1
	call wnkey
	call wkey
;space - next
	ld a,$7F
	in a,($FE)
	rra
	jr c,backmnu
	ld a,(cy)
	cp 11
	jr z,backmnu
	inc a
	ld (cy),a
	jp extract
	jr $
backmnu:
 	jp runi
pr8x4:
	ld a,(ix+0):inc ix
	or a:ret z
;1
	ld l,a
	ld h,0
	ld bc,f8x4
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,d
 dup 8
 ld a,(hl)
 ld (de),a
 inc hl
 inc d
edup
	ld d,b

	ld a,(ix+0):inc ix
	or a:ret z
;2
	ld l,a
	ld h,0
	ld bc,f8x4
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,bc
	ld b,d
 dup 8
	ld a,(de)
	ld c,a
 ld a,(hl)
 rrca
 rrca
 rrca
 rrca
 or c
 ld (de),a
 inc hl
 inc d
edup
	ld d,b
	inc e
	jp pr8x4
wkey:
	xor a
	in a,($FE)
	cpl
	and 31
	jr z,wkey
	ret
wnkey:
	xor a
	in a,($FE)
	cpl
	and 31
	jr nz,wnkey
	ret

;
intvec:
	push ix;,iy
	push hl,de,bc,af
	exx:exa
	push hl,de,bc,af
	CALL PLAY
	pop af,bc,de,hl
	exx:exa
	pop af,bc,de,hl
	pop ix
	ei:ret

ramk:
	push af
	ld hl,(cy)
	ld h,0
	ld de,$5840
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,hl
	add hl,de
	ld b,32
ra1:
	ld a,(hl)
	xor 1*8+1
	ld (hl),a
	inc l
	djnz ra1
	pop af
	ret
cy:db 0 ; cursor Y
;
plyr:include "PTxPlay.a80"
f8x4 incbin "8x4.fnt"
zxf incbin "ZX_SPECTRUM.fnt.zx7"
zx7:include "zx7.a80"
t1: db "             , zxgfx compo #5, 30.07.2022",0
 db " ",0
    db "1.- ? - , ... by Art-top vts:32 pts:281 avg:8.78",0
    db "2.SpecSCII Underwater World by pixelrat vts:32 pts:265 avg:8.28",0
    db "3.Scuba Platformer Mock-up by Grongy vts:32 pts:263 avg:8.22",0
    db "4.Pineapple Under the Sea by Grongy vts:33 pts:270 avg:8.18",0
    db "5.Coral Reef by Grongy vts:32 pts:255 avg:7.97",0
    db "6. ᨭ ,   . by Art-top vts:32 pts:249 avg:7.78",0
    db "7.Exoquarium by pixelrat vts:32 pts:246 avg:7.69",0
    db "8.Dire Dire Dock by pixelrat vts:31 pts:229 avg:7.39",0
    db "9.z80 water physics by Grongy vts:33 pts:206 avg:6.24",0
    db "10.Krym by aGGreSSor vts:31 pts:188 avg:6.06",0
    db "11.㫠  by Grongy vts:32 pts:190 avg:5.94",0
    db "12.Scubas by g0blinish vts:30 pts:153 avg:5.10",0
 db 0 ; end of list
 
t2: db "Q,8-up A,9-down, M/0/Enter-show Space-next",0;,0
end
	page 0
	org $C000
page0b:
 DEFINE pg0
pic1:incbin "pg0\01.bin.zx7"
pic2:incbin "pg0\02.bin.zx7"
pic3:incbin "pg0\03.bin.zx7"
pic4:incbin "pg0\04.bin.zx7"
pic5:incbin "pg0\05.bin.zx7"
pic6:incbin "pg0\06.bin.zx7"
pic7:incbin "pg0\07.bin.zx7"
pic8:incbin "pg0\08.bin.zx7"
pic9:incbin "pg0\09.bin.zx7"
pic10:incbin "pg0\10.bin.zx7"
pic11:incbin "pg0\11.bin.zx7"
pic12:incbin "pg0\12.bin.zx7"
song:incbin "2022_mmcm_summer_trip.pt3"
page0e:
	display /d,end-begin
	savesna "!void.sna",begin
	savebin "owss.bin",begin,end-begin
	page 0
	savebin "owp0.bin",page0b,page0e-page0b
;-----------------------------------------------------------
;add after
;page0b:
; DEFINE pg0

 macro	sectors datab,datae

	db 1,5,(datae-datab+255)/256
; IF low (datae-datab)=0
;   db 1,5,high (datae-datab)
; ELSE
;   db 1,5,(1+high (datae-datab))
; ENDIF
;
	endm

 MODULE boot
Basic:
 db #00,#01; ப
 DW EndLine1 - Line1
Line1:
 db #EA;REM

 ;test 128K
;	ld hl,$FFFF
;	ld bc,$7FFD
;	ld de,$1011
;	out (c),d:ld (hl),d
;	out (c),e:ld (hl),e
;	out (c),d
;	ld a,(hl):cp d:ret nz

	 ld sp,#5FFF
    res 4,(iy+1)
    xor a:out ($FE),a
    ld hl,$5AFF,de,$5AFe,bc,$1B00-1,(hl),0:lddr

;title
;	IFUSED tit_b
; di
; ld de,(#5CF4)
; ld hl, #6000
;; ld a,#10,bc,#7FFD:out (c),a
; sectors tit_b,tit_e
; call #3d13
; call #6000
;	ENDIF

;demo
 di
 ld de,(#5CF4)
 ld hl, #6000
 ld a,#10,bc,#7FFD:out (c),a
 sectors begin,end
 call #3d13

	IFDEF pg0
 di
 ld de,(#5CF4)
 ld hl, #C000
 sectors page0b,page0e
 call #3d13
	ENDIF

	IFDEF pg1
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#11,bc,#7FFD:out (c),a
 sectors page1b,page1e
 call #3d13
	ENDIF

	IFDEF pg3
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#13,bc,#7FFD:out (c),a
 sectors page3b,page3e
 call #3d13
	ENDIF

	IFDEF pg4
 di
 ld de,(#5CF4)
 ld hl, #C000
 ld a,#14,bc,#7FFD:out (c),a
 sectors page4b,page4e
 call #3d13
	ENDIF

 ld a,#10,bc,#7ffd:out (c),a
 jp begin


 db "fuckhype"
 db #0D
EndLine1:
 db #00,#02
 DW EndLine2 - Line2
Line2:
 db #20,#FD,#B0
 db #22,#32,#34,#35,#37,#35,#22;clear val "24575"
 db #3A; :
 db #F9,#C0,#28,#35;randomize usr (5+256*peek val "23635"+peek val "23636"
 db #0E,#00,#00,#05,#00,#00,#2B
 db #32,#35,#36
 db #0E,#00,#00,#00,#01,#00,#2A,#BE

 db #B0
 db #22,#32,#33,#36,#33,#36,#22;"23635"
 db #2B;???
 db #BE
 db #B0
 db #22,#32,#33,#36,#33,#35,#22;"23636"
 db #29

;+128K
;	db ":",245 ;:PRINT
;	db 34,17,0,16,7,"128K only",34
 
 db #0D;)
 db #80
 db #AA,1,0;;;;;;;;;;;;;autorun line,change program length to -4, e.g. 83-4=79
EndLine2:
EndBasic:
 ENDMODULE

	display /d,end-begin

    EMPTYTRD "dust.trd" ;create empty TRD image
	SAVETRD "dust.trd", "owss.B", boot.Basic, boot.EndBasic - boot.Basic

;	IFUSED tit_b
;    SAVETRD "dust.trd","pict.C",tit_b,tit_e-tit_b
;	ENDIF

    SAVETRD "dust.trd","demo.C",begin,end-begin

	IFDEF pg0
    PAGE 0
    SAVETRD "dust.trd","pg0.C",page0b,page0e-page0b
	ENDIF

	IFDEF pg1
    PAGE 1
    SAVETRD "dust.trd","pg1.C",page1b,page1e-page1b
	ENDIF

	IFDEF pg3
    PAGE 3
    SAVETRD "dust.trd","pg3.C",page3b,page3e-page3b
	ENDIF

	IFDEF pg4
    PAGE 4
    SAVETRD "dust.trd","pg4.C",page4b,page4e-page4b
	ENDIF

;-----------------------------------------------------------


